"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var react_1 = require("@storybook/react");
var storybook_chrome_screenshot_1 = require("storybook-chrome-screenshot");
var with_readme_1 = require("storybook-readme/with-readme");
var __1 = require("../");
var TextWithCopy_md_1 = require("./README/TextWithCopy.md");
react_1.storiesOf('Core/TextWithCopy', module)
    .addDecorator(with_readme_1.default(TextWithCopy_md_1.default))
    .addDecorator(storybook_chrome_screenshot_1.withScreenshot())
    .add('Standard', function () {
    return (React.createElement(__1.Provider, null,
        React.createElement(__1.Box, { m: 3 },
            React.createElement(__1.TextWithCopy, { copy: 'This value has been copied to your clipboard!' },
                React.createElement("i", null, "hover"),
                " & ",
                React.createElement("b", null, "click"),
                " the icon"))));
})
    .add('Wrapping text', function () {
    return (React.createElement(__1.Provider, null,
        React.createElement(__1.Box, { m: 3, w: 300 },
            React.createElement(__1.TextWithCopy, { copy: 'This value has been copied to your clipboard!' }, "hover & click ... ... ... ... ... ... ... ... ... ... ... ... the icon on the wrapped text"))));
})
    .add('Always showing the copy icon', function () {
    return (React.createElement(__1.Provider, null,
        React.createElement(__1.Box, { m: 3, w: 300 },
            React.createElement(__1.TextWithCopy, { showCopyButton: 'always', copy: 'This value has been copied to your clipboard!' }, "click the icon"))));
})
    .add('Inside clickable element', function () {
    return (React.createElement(__1.Provider, null,
        React.createElement(__1.Box, { m: 3 },
            React.createElement(__1.Link, { href: '#foobar', style: { display: 'block' } },
                React.createElement(__1.Flex, null,
                    React.createElement(__1.Box, { mr: 5 }, "Link Text"),
                    React.createElement(__1.Box, null,
                        React.createElement(__1.TextWithCopy, { copy: 'This value has been copied to your clipboard!' }, "hover & click the icon")))))));
});
